/* trace.c -- Simulator breakpoints
   Copyright (C) 1999 Damjan Lampret, lampret@opencores.org

This file is part of OpenRISC 1000 Architectural Simulator.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <stdarg.h>

#include "arch.h"
#include "parse.h"
#include "abstract.h"
#include "trace.h"
#include "execute.h"

/* Set instruction execution breakpoint. */

void set_insnbrkpoint(unsigned long addr)
{
	addr &= 0xfffffffc;	/* 32-bit aligned */
	
	if (addr < (MEMORY_START + MEMORY_LEN))
		if (mem[addr].brk) {
			mem[addr].brk = 0;
			printf("\nBreakpoint at 0x%.8lx cleared.\n", addr);
		} else {
			mem[addr].brk = 1;
			printf("\nBreakpoint at 0x%.8lx set.\n", addr);
		}
	else
		printf("ERROR: Can't set this breakpoint out of memory.\n");
	
	return;
}

