/* config.h -- Simulator configuration header file
   Copyright (C) 1999 Damjan Lampret, lampret@opencores.org
   
   This file is part of OpenRISC 1000 Architectural Simulator.
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
   
/* Simulator configuration macros. Eventually this one will be a lot bigger. */

#define NR_UARTS        4       /* Number of UARTs simulated */   
#define NONE		0
#define VIRTUAL		1
#define PHYSICAL	2

struct config {
	struct {
		int tagtype;
	} dc;
	int clkcycle_ns;	/* Clock cycle in nanoseconds */
	struct {
		char *rxfile;	/* File for RX */
		char *txfile;	/* File for TX (required) */
		unsigned long baseaddr; /* Naturally aligned base address */
	} uarts[NR_UARTS];
	struct {
		unsigned long startaddr;
		unsigned long endaddr;
	} ram;
};
                                
extern struct config config;
